/**
 * # redux > TEMPLATE > reducer.js
 *
 * This file contain all TEMPLATE Reducers
 */

// Import all the types
'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = authReducer;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _types = require('./types');

var _types2 = _interopRequireDefault(_types);

// Import TEMPLATE InitialState

var _InitialState = require('./InitialState');

var _InitialState2 = _interopRequireDefault(_InitialState);

var initialState = new _InitialState2['default']();

/**
 * ## authReducer function
 * @param {Object} state - initialState
 * @param {Object} action - type and payload
 */

function authReducer(state, action) {
  if (state === undefined) state = initialState;

  if (!(state instanceof _InitialState2['default'])) return initialState.merge(state);

  switch (action.type) {
    // storage
    case _types2['default'].SET_SESSION_TOKEN_STATUS:
      {
        return state.set('sessionTokenStatus', action.status);
      }
    // store
    case _types2['default'].CLEAR_AUTH_FORM:
      {
        return state.remove('authForm');
      }
    case _types2['default'].SET_VALUE_IN_AUTH_FORM_BY_KEY:
      {
        if (!action.key) return state;
        return state.setIn(['authForm', action.key], action.value);
      }
    // query status
    case _types2['default'].SET_AUTH_QUERY_STATUS:
      {
        return state.set('sessionTokenCheckStatus', action.status);
      }
    default:
      return state;
  }
}

module.exports = exports['default'];