/**
 * # redux > TEMPLATE > sagaWatcher.js
 *
 * This file contain all TEMPLATE Watcher
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var marked0$0 = [authWatcher].map(regeneratorRuntime.mark);

var _reduxSagaEffects = require('redux-saga/effects');

// Import all the ActionTypes

var _types = require('./types');

var _types2 = _interopRequireDefault(_types);

// Import all workers from Workers Folder

var _sagaWorkersLoginWorker = require('./sagaWorkers/loginWorker');

var _sagaWorkersLoginWorker2 = _interopRequireDefault(_sagaWorkersLoginWorker);

var _sagaWorkersRegisterWorker = require('./sagaWorkers/registerWorker');

var _sagaWorkersRegisterWorker2 = _interopRequireDefault(_sagaWorkersRegisterWorker);

var _sagaWorkersLogoutWorker = require('./sagaWorkers/logoutWorker');

var _sagaWorkersLogoutWorker2 = _interopRequireDefault(_sagaWorkersLogoutWorker);

// storage

var _sagaWorkersGetSessionTokenWorker = require('./sagaWorkers/getSessionTokenWorker');

var _sagaWorkersGetSessionTokenWorker2 = _interopRequireDefault(_sagaWorkersGetSessionTokenWorker);

var _sagaWorkersSetSessionTokenWorker = require('./sagaWorkers/setSessionTokenWorker');

var _sagaWorkersSetSessionTokenWorker2 = _interopRequireDefault(_sagaWorkersSetSessionTokenWorker);

var _sagaWorkersRemoveSessionTokenWorker = require('./sagaWorkers/removeSessionTokenWorker');

var _sagaWorkersRemoveSessionTokenWorker2 = _interopRequireDefault(_sagaWorkersRemoveSessionTokenWorker);

// all TEMPLATE watchers
function authWatcher() {
  return regeneratorRuntime.wrap(function authWatcher$(context$1$0) {
    while (1) switch (context$1$0.prev = context$1$0.next) {
      case 0:
        context$1$0.next = 2;
        return (0, _reduxSagaEffects.takeEvery)(_types2['default'].AUTH_LOGIN, _sagaWorkersLoginWorker2['default']);

      case 2:
        context$1$0.next = 4;
        return (0, _reduxSagaEffects.takeEvery)(_types2['default'].AUTH_REGISTER, _sagaWorkersRegisterWorker2['default']);

      case 4:
        context$1$0.next = 6;
        return (0, _reduxSagaEffects.takeEvery)(_types2['default'].AUTH_LOGOUT, _sagaWorkersLogoutWorker2['default']);

      case 6:
        context$1$0.next = 8;
        return (0, _reduxSagaEffects.takeEvery)(_types2['default'].GET_SESSION_TOKEN_FROM_STORAGE, _sagaWorkersGetSessionTokenWorker2['default']);

      case 8:
        context$1$0.next = 10;
        return (0, _reduxSagaEffects.takeEvery)(_types2['default'].SET_SESSION_TOKEN_IN_STORAGE, _sagaWorkersSetSessionTokenWorker2['default']);

      case 10:
        context$1$0.next = 12;
        return (0, _reduxSagaEffects.takeEvery)(_types2['default'].REMOVE_SESSION_TOKEN_FROM_STORAGE, _sagaWorkersRemoveSessionTokenWorker2['default']);

      case 12:
      case 'end':
        return context$1$0.stop();
    }
  }, marked0$0[0], this);
}
exports['default'] = authWatcher;
module.exports = exports['default'];

// login

// register

// logout

// storage