'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = getSessionTokenWorker;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var marked0$0 = [getSessionTokenWorker].map(regeneratorRuntime.mark);

var _reduxSagaEffects = require('redux-saga/effects');

var _serverApi = require('../../server/api');

var _serverApi2 = _interopRequireDefault(_serverApi);

var _types = require('../types');

var _types2 = _interopRequireDefault(_types);

function getAuthTokenFormStorage() {
  if (localStorage) {
    return JSON.parse(localStorage.getItem(_types2['default'].SESSION_TOKEN_KEY));
  }
  return null;
}

function getSessionTokenWorker() {
  var authToken;
  return regeneratorRuntime.wrap(function getSessionTokenWorker$(context$1$0) {
    while (1) switch (context$1$0.prev = context$1$0.next) {
      case 0:
        context$1$0.next = 2;
        return (0, _reduxSagaEffects.put)({
          type: _types2['default'].SESSION_TOKEN_IN_STORAGE_STATUS,
          status: _types2['default'].GET_SESSION_START
        });

      case 2:
        authToken = getAuthTokenFormStorage();

        if (!(authToken && authToken.sessionToken)) {
          context$1$0.next = 11;
          break;
        }

        context$1$0.next = 6;
        return (0, _reduxSagaEffects.put)({ type: _types2['default'].SET_USER_IN_STORE, payload: authToken });

      case 6:
        _serverApi2['default'].setSessionToken(authToken.sessionToken);
        context$1$0.next = 9;
        return (0, _reduxSagaEffects.put)({
          type: _types2['default'].SESSION_TOKEN_IN_STORAGE_STATUS,
          status: _types2['default'].GET_SESSION_SUCCESSFULLY
        });

      case 9:
        context$1$0.next = 11;
        return (0, _reduxSagaEffects.put)({
          type: _types2['default'].SET_SESSION_TOKEN_IN_STORAGE,
          sessionToken: authToken.sessionToken
        });

      case 11:
        context$1$0.next = 13;
        return (0, _reduxSagaEffects.put)({
          type: _types2['default'].SESSION_TOKEN_IN_STORAGE_STATUS,
          status: _types2['default'].GET_SESSION__FAILED
        });

      case 13:
      case 'end':
        return context$1$0.stop();
    }
  }, marked0$0[0], this);
}

module.exports = exports['default'];