'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = loginWorker;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var marked0$0 = [loginWorker].map(regeneratorRuntime.mark);

var _serverApi = require('../../server/api');

var _serverApi2 = _interopRequireDefault(_serverApi);

var _serverApiSagaWrapper = require('../../server/apiSagaWrapper');

var _reduxSagaEffects = require('redux-saga/effects');

var _types = require('../types');

var _types2 = _interopRequireDefault(_types);

function loginWorker() {
  var authForm, res, user;
  return regeneratorRuntime.wrap(function loginWorker$(context$1$0) {
    while (1) switch (context$1$0.prev = context$1$0.next) {
      case 0:
        context$1$0.next = 2;
        return (0, _reduxSagaEffects.select)(function (state) {
          return state.auth.authForm;
        });

      case 2:
        authForm = context$1$0.sent;
        context$1$0.next = 5;
        return (0, _reduxSagaEffects.put)({ type: _types2['default'].SET_AUTH_QUERY_STATUS, status: _types2['default'].LOGIN_START });

      case 5:
        return context$1$0.delegateYield((0, _serverApiSagaWrapper.httpRequest)(_serverApi2['default'].login, authForm.email, authForm.password), 't0', 6);

      case 6:
        res = context$1$0.t0;

        if (!res.error) {
          context$1$0.next = 12;
          break;
        }

        context$1$0.next = 10;
        return (0, _reduxSagaEffects.put)({
          type: _types2['default'].SET_AUTH_QUERY_STATUS,
          status: _types2['default'].LOGIN_FAILED
        });

      case 10:
        context$1$0.next = 21;
        break;

      case 12:
        user = res.data;
        context$1$0.next = 15;
        return (0, _reduxSagaEffects.put)({ type: _types2['default'].SET_USER_IN_STORE, user: user });

      case 15:
        context$1$0.next = 17;
        return (0, _reduxSagaEffects.put)({
          type: _types2['default'].SET_SESSION_TOKEN_IN_STORAGE,
          sessionToken: user.sessionToken
        });

      case 17:
        context$1$0.next = 19;
        return (0, _reduxSagaEffects.put)({ type: _types2['default'].CLEAR_AUTH_FORM });

      case 19:
        context$1$0.next = 21;
        return (0, _reduxSagaEffects.put)({
          type: _types2['default'].SET_AUTH_QUERY_STATUS,
          status: _types2['default'].LOGIN_SUCCESSFULLY
        });

      case 21:
      case 'end':
        return context$1$0.stop();
    }
  }, marked0$0[0], this);
}

module.exports = exports['default'];
// Make the request

// Handle Success