'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x5, _x6, _x7) { var _again = true; _function: while (_again) { var object = _x5, property = _x6, receiver = _x7; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x5 = parent; _x6 = property; _x7 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRedux = require('react-redux');

var _redux = require('redux');

var _reduxActions = require('./redux/actions');

var parseActions = _interopRequireWildcard(_reduxActions);

var _reduxConsts = require('./redux/consts');

var _reduxConsts2 = _interopRequireDefault(_reduxConsts);

var _lodashIsEqual = require('lodash/isEqual');

var _lodashIsEqual2 = _interopRequireDefault(_lodashIsEqual);

var _reduxParseSelectors = require('./redux/parseSelectors');

var LOADING = _reduxConsts2['default'].LOADING;
var CREATE_DOCUMENT_START = _reduxConsts2['default'].CREATE_DOCUMENT_START;
var CREATE_DOCUMENT_SUCCESS = _reduxConsts2['default'].CREATE_DOCUMENT_SUCCESS;
var CREATE_DOCUMENT_ERROR = _reduxConsts2['default'].CREATE_DOCUMENT_ERROR;
var DELETE_DOCUMENT_START = _reduxConsts2['default'].DELETE_DOCUMENT_START;
var DELETE_DOCUMENT_SUCCESS = _reduxConsts2['default'].DELETE_DOCUMENT_SUCCESS;
var DELETE_DOCUMENT_ERROR = _reduxConsts2['default'].DELETE_DOCUMENT_ERROR;
var UPDATE_DOCUMENT_START = _reduxConsts2['default'].UPDATE_DOCUMENT_START;
var UPDATE_DOCUMENT_SUCCESS = _reduxConsts2['default'].UPDATE_DOCUMENT_SUCCESS;
var UPDATE_DOCUMENT_ERROR = _reduxConsts2['default'].UPDATE_DOCUMENT_ERROR;

var FetchDocument = (function (_React$PureComponent) {
  _inherits(FetchDocument, _React$PureComponent);

  function FetchDocument(props) {
    _classCallCheck(this, FetchDocument);

    _get(Object.getPrototypeOf(FetchDocument.prototype), 'constructor', this).call(this, props);
    this.getDataFromServerIsRun = false;
    this.getDataFromServer = this.getDataFromServer.bind(this);
    this.onDeleteDocument = this.onDeleteDocument.bind(this);
    this.onChangeValueByKey = this.onChangeValueByKey.bind(this);
    this.onRefreshData = this.onRefreshData.bind(this);
    this.getQueryStatus = this.getQueryStatus.bind(this);
    this.onSave = this.onSave.bind(this);
  }

  _createClass(FetchDocument, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.initialState();
    }
  }, {
    key: 'initialState',
    value: function initialState() {
      var props = arguments.length <= 0 || arguments[0] === undefined ? this.props : arguments[0];
      var localFirst = props.localFirst;
      var collectionName = props.collectionName;
      var objectId = props.objectId;

      if (objectId && collectionName) {
        if (!localFirst || !this.isDataExistOrQueryIsLoading()) {
          this.getDataFromServer(props);
        }
      } else {
        this.createLocalDocument();
      }
    }
  }, {
    key: 'getDataFromServer',
    value: function getDataFromServer() {
      var props = arguments.length <= 0 || arguments[0] === undefined ? this.props : arguments[0];
      var localOnly = arguments.length <= 1 || arguments[1] === undefined ? this.props.localOnly : arguments[1];

      if (localOnly) return;
      var collectionName = props.collectionName;
      var objectId = props.objectId;
      var include = props.include;

      if (!objectId || !collectionName) return;
      this.getDataFromServerIsRun = true;
      this.props.onGetStart();
      this.props.actions.getDocumentByObjectId(collectionName, objectId, include);
    }
  }, {
    key: 'createLocalDocument',
    value: function createLocalDocument() {
      this.props.onCreateLocalDocument(this.props.uniqueId);
      this.props.actions.createLocalDocumentByUniqueId(this.props.uniqueId, this.props.initialValues);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      // Params from parent was changed
      if (this.isParamsChanged(nextProps)) {
        console.warn('params changed, initialState');
        this.initialState(nextProps);
      }
      // GET DATA FINISH
      if (this.isGetFinish(nextProps)) {
        this.getDataFromServerIsRun = false;
        this.props.onGetFinish({ queryStatus: nextProps.queryStatus, data: nextProps.data });
      }
      // CREATE DOCUMENT FINISH
      if (this.isCreateDocumentFinish(nextProps)) {
        this.props.onPostDocumentFinish({
          status: nextProps.queryStatus.status,
          objectId: nextProps.queryStatus.objectId,
          data: nextProps.queryStatus.data
        });
      }
      // DELETE DOCUMENT FINISH
      if (this.isDeleteDocumentFinish(nextProps)) {
        this.props.onDeleteDocumentFinish(nextProps.queryStatus);
      }
      // UPDATE DOCUMENT FINISH
      if (this.isUpdateDocumentFinish(nextProps)) {
        this.props.onPutDocumentFinish(nextProps.queryStatus);
      }
    }
  }, {
    key: 'isGetFinish',
    value: function isGetFinish(nextProps) {
      if (this.props.queryStatus === LOADING && nextProps.queryStatus !== LOADING && (this.getDataFromServerIsRun || this.isDataChanged(nextProps))) {
        return true;
      }
      return false;
    }
  }, {
    key: 'isCreateDocumentFinish',
    value: function isCreateDocumentFinish(nextProps) {
      return this.getQueryStatus() === CREATE_DOCUMENT_START && (this.getQueryStatus(nextProps) === CREATE_DOCUMENT_SUCCESS || this.getQueryStatus(nextProps) === CREATE_DOCUMENT_ERROR);
    }
  }, {
    key: 'isDeleteDocumentFinish',
    value: function isDeleteDocumentFinish(nextProps) {
      return this.props.queryStatus === DELETE_DOCUMENT_START && (nextProps.queryStatus === DELETE_DOCUMENT_SUCCESS || nextProps.queryStatus === DELETE_DOCUMENT_ERROR);
    }
  }, {
    key: 'isUpdateDocumentFinish',
    value: function isUpdateDocumentFinish(nextProps) {
      return this.props.queryStatus === UPDATE_DOCUMENT_START && (nextProps.queryStatus === UPDATE_DOCUMENT_SUCCESS || nextProps.queryStatus === UPDATE_DOCUMENT_ERROR);
    }
  }, {
    key: 'isDataChanged',
    value: function isDataChanged(nextProps) {
      return this.props.data !== nextProps.data;
    }
  }, {
    key: 'isQueryStatusChanged',
    value: function isQueryStatusChanged(nextProps) {
      return this.props.queryStatus !== nextProps.queryStatus;
    }
  }, {
    key: 'isParamsChanged',
    value: function isParamsChanged(nextProps) {
      // collectionName was change, get data from server
      if (this.props.collectionName !== nextProps.collectionName) {
        return true;
      }
      if (this.props.objectId !== nextProps.objectId) {
        return true;
      }
      if (this.props.include !== nextProps.include) {
        return true;
      }
      if (!(0, _lodashIsEqual2['default'])(this.props.initialValues, nextProps.initialValues)) {
        return false; //initialValues only on load fow noe
      }
      return false;
    }
  }, {
    key: 'isDataExistOrQueryIsLoading',
    value: function isDataExistOrQueryIsLoading() {
      var _props = this.props;
      var queryStatus = _props.queryStatus;
      var data = _props.data;

      if (data || queryStatus === LOADING) {
        return true;
      }
      return false;
    }

    // Clean data on Mount
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this.props.cleanDataOnComponentWillUnmount) {
        this.removerDataFromStore();
      }
    }
  }, {
    key: 'removerDataFromStore',
    value: function removerDataFromStore() {
      if (this.props.objectId) {
        this.props.actions.removeLocalDocumentByObjectId(this.props.objectId);
      }
      if (this.props.uniqueId) {
        this.props.actions.removeLocalDocumentByUniqueId(this.props.uniqueId);
      }
    }

    // shouldComponentUpdate (nextProps, nextState) {
    //   if(this.isDataChanged(nextProps) || this.isQueryStatusChanged(nextProps) || this.isParamsChanged(nextProps)) {
    //     return true
    //   }
    //   return false
    // }
  }, {
    key: 'onDeleteDocument',
    value: function onDeleteDocument() {
      var _props2 = this.props;
      var objectId = _props2.objectId;
      var collectionName = _props2.collectionName;

      if (objectId) {
        if (this.props.queryStatus === DELETE_DOCUMENT_START) return;
        this.props.onDeleteDocumentStart(objectId);
        this.props.actions.deleteDocumentFromServerByObjectId(collectionName, objectId);
      } else {
        this.removerDataFromStore();
      }
    }
  }, {
    key: 'onRefreshData',
    value: function onRefreshData() {
      this.getDataFromServer(null, false);
    }
  }, {
    key: 'onSave',
    value: function onSave() {
      var _props3 = this.props;
      var collectionName = _props3.collectionName;
      var objectId = _props3.objectId;
      var parseDataBeforeSave = _props3.parseDataBeforeSave;
      var addMemberPointerToDataOnPost = _props3.addMemberPointerToDataOnPost;
      var getDataWithPostFinishCallBack = _props3.getDataWithPostFinishCallBack;

      if (objectId) {
        this.props.onPutDocumentStart();
        this.props.actions.updateDocumentOnServerByObjectId(collectionName, objectId, null, null, parseDataBeforeSave);
      } else {
        this.props.onPostDocumentStart();
        this.props.actions.postLocalDocumentByUniqueIdToServer(collectionName, this.props.uniqueId, parseDataBeforeSave, addMemberPointerToDataOnPost, getDataWithPostFinishCallBack);
      }
    }
  }, {
    key: 'onChangeValueByKey',
    value: function onChangeValueByKey(key, value) {
      var objectId = this.props.objectId;

      if (objectId) {
        this.props.actions.updateLocalDocumentByObjectId(objectId, key, value);
      } else {
        this.props.actions.updateLocalDocumentByUniqueId(this.props.uniqueId, key, value);
      }
    }
  }, {
    key: 'getQueryStatus',
    value: function getQueryStatus() {
      var props = arguments.length <= 0 || arguments[0] === undefined ? this.props : arguments[0];
      var objectId = props.objectId;
      var queryStatus = props.queryStatus;

      if (objectId) return queryStatus;
      var status = queryStatus ? queryStatus.status : null;
      return status;
    }
  }, {
    key: 'render',
    value: function render() {
      var data = this.props.data;
      var queryStatus = this.getQueryStatus();
      var deleteDocument = this.onDeleteDocument;
      var changeValueByKey = this.onChangeValueByKey;
      var refreshData = this.onRefreshData;
      var saveDocument = this.onSave;
      return this.props.render({ data: data, queryStatus: queryStatus, refreshData: refreshData, deleteDocument: deleteDocument, changeValueByKey: changeValueByKey, saveDocument: saveDocument });
    }
  }]);

  return FetchDocument;
})(_react2['default'].PureComponent);

function mapStateToProps(state, props) {
  var objectId = props.objectId;
  var uniqueId = props.uniqueId;
  return {
    data: objectId ? (0, _reduxParseSelectors.getDocumentByObjectId)(state, objectId) : (0, _reduxParseSelectors.getDocumentByUniqueId)(state, uniqueId),
    queryStatus: objectId ? (0, _reduxParseSelectors.getDocumentQueryStatusByObjectId)(state, objectId) : (0, _reduxParseSelectors.getDocumentQueryStatusByUniqueId)(state, uniqueId)
  };
}

function mapDispatchToProps(dispatch) {
  return {
    actions: (0, _redux.bindActionCreators)(_extends({}, parseActions), dispatch)
  };
}

exports['default'] = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(FetchDocument);

FetchDocument.propTypes = {
  collectionName: _propTypes2['default'].string.isRequired,
  objectId: _propTypes2['default'].string,
  collectionTarget: _propTypes2['default'].string, // need this value for automatic refresh collection on store after document changed
  render: _propTypes2['default'].func.isRequired, // render({data, queryStatus, refreshData, deleteDocument, updateDocument})
  include: _propTypes2['default'].string,
  initialValues: _propTypes2['default'].object,
  onCreateLocalDocument: _propTypes2['default'].func,
  onGetStart: _propTypes2['default'].func,
  onGetFinish: _propTypes2['default'].func,
  onPostDocumentStart: _propTypes2['default'].func,
  onPostDocumentFinish: _propTypes2['default'].func,
  onDeleteDocumentStart: _propTypes2['default'].func,
  onDeleteDocumentFinish: _propTypes2['default'].func,
  onPutDocumentStart: _propTypes2['default'].func,
  onPutDocumentFinish: _propTypes2['default'].func,
  addMemberPointerToDataOnPost: _propTypes2['default'].bool,
  cleanDataOnComponentWillUnmount: _propTypes2['default'].bool,
  getDataWithPostFinishCallBack: _propTypes2['default'].bool, // this trigger a GET method after POST and the data pass with onPostDocumentFinish
  localFirst: _propTypes2['default'].bool, // get data from server only if data didn't found in store
  localOnly: _propTypes2['default'].bool, // get data only from local store
  parseDataBeforeSave: _propTypes2['default'].func
};

FetchDocument.defaultProps = {
  cleanDataOnComponentWillUnmount: true,
  getDataWithPostFinishCallBack: false,
  onCreateLocalDocument: function onCreateLocalDocument() {
    console.log('Document: onCreateLocalDocument');
  },
  onGetFinish: function onGetFinish() {
    console.log('Document: onGetFinish');
  },
  onGetStart: function onGetStart() {
    console.log('Document: onGetStart');
  },
  onDeleteDocumentStart: function onDeleteDocumentStart() {
    console.log('Document: onDeleteDocumentStart');
  },
  onDeleteDocumentFinish: function onDeleteDocumentFinish() {
    console.log('Document: onDeleteDocumentFinish');
  },
  onPutDocumentStart: function onPutDocumentStart() {
    console.log('Document: onPutDocumentStart');
  },
  onPutDocumentFinish: function onPutDocumentFinish() {
    console.log('Document: onPutDocumentFinish');
  },
  onPostDocumentStart: function onPostDocumentStart() {
    console.log('Document: onPostDocumentStart');
  },
  onPostDocumentFinish: function onPostDocumentFinish() {
    console.log('Document: onPostDocumentFinish');
  },
  parseDataBeforeSave: function parseDataBeforeSave(data) {
    return data;
  }

};
module.exports = exports['default'];