'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x3, _x4, _x5) { var _again = true; _function: while (_again) { var object = _x3, property = _x4, receiver = _x5; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x3 = parent; _x4 = property; _x5 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRedux = require('react-redux');

var _redux = require('redux');

var _reduxActions = require('./redux/actions');

var parseActions = _interopRequireWildcard(_reduxActions);

var _reduxConsts = require('./redux/consts');

var _reduxConsts2 = _interopRequireDefault(_reduxConsts);

var _reduxParseSelectors = require('./redux/parseSelectors');

var _lodashIsEqual = require('lodash/isEqual');

var _lodashIsEqual2 = _interopRequireDefault(_lodashIsEqual);

var LOADING = _reduxConsts2['default'].LOADING;
var CLOUD_CODE_DELETE_DOCUMENT_START = _reduxConsts2['default'].CLOUD_CODE_DELETE_DOCUMENT_START;
var CLOUD_CODE_DELETE_DOCUMENT_SUCCESS = _reduxConsts2['default'].CLOUD_CODE_DELETE_DOCUMENT_SUCCESS;
var CLOUD_CODE_DELETE_DOCUMENT_ERROR = _reduxConsts2['default'].CLOUD_CODE_DELETE_DOCUMENT_ERROR;
var CLOUD_CODE_UPDATE_DOCUMENT_START = _reduxConsts2['default'].CLOUD_CODE_UPDATE_DOCUMENT_START;
var CLOUD_CODE_UPDATE_DOCUMENT_SUCCESS = _reduxConsts2['default'].CLOUD_CODE_UPDATE_DOCUMENT_SUCCESS;
var CLOUD_CODE_UPDATE_DOCUMENT_ERROR = _reduxConsts2['default'].CLOUD_CODE_UPDATE_DOCUMENT_ERROR;

var FetchCloudCode = (function (_React$PureComponent) {
  _inherits(FetchCloudCode, _React$PureComponent);

  function FetchCloudCode(props) {
    _classCallCheck(this, FetchCloudCode);

    _get(Object.getPrototypeOf(FetchCloudCode.prototype), 'constructor', this).call(this, props);
    this.getDataFromServerIsRun = false;
    this.getDataFromServer = this.getDataFromServer.bind(this);
    this.onDeleteDocument = this.onDeleteDocument.bind(this);
    this.onUpdateDocument = this.onUpdateDocument.bind(this);
    this.onRefreshData = this.onRefreshData.bind(this);
  }

  _createClass(FetchCloudCode, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _props = this.props;
      var localFirst = _props.localFirst;
      var functionName = _props.functionName;

      if (functionName && (!localFirst || !this.isDataExistOrQueryIsLoading())) {
        this.getDataFromServer();
      }
    }
  }, {
    key: 'getDataFromServer',
    value: function getDataFromServer() {
      var props = arguments.length <= 0 || arguments[0] === undefined ? this.props : arguments[0];
      var localOnly = arguments.length <= 1 || arguments[1] === undefined ? this.props.localOnly : arguments[1];

      if (localOnly) return;
      var functionName = props.functionName;
      var collectionTarget = props.collectionTarget;
      var params = props.params;
      var filterByMemberId = props.filterByMemberId;
      var memberFieldName = props.memberFieldName;
      var digToDataString = props.digToDataString;

      if (!functionName) return;
      this.getDataFromServerIsRun = true;
      this.props.onGetStart();
      this.props.actions.getDataByCloudCodeName(functionName, collectionTarget, params, filterByMemberId, memberFieldName, digToDataString);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      // Params from parent was changed
      if (this.isPropsFromParentChanged(nextProps)) {
        this.getDataFromServer(nextProps);
      }
      // GET DATA FINISH
      if (this.isGetFinish(nextProps)) {
        this.getDataFromServerIsRun = false;
        this.props.onGetFinish({ queryStatus: nextProps.queryStatus, data: nextProps.data });
      }
      // DELETE DOCUMENT FINISH
      if (this.isDeleteDocumentFinish(nextProps)) {
        this.getDataFromServer(nextProps);
        this.props.onDeleteDocumentFinish(nextProps.queryStatus);
      }
      // UPDATE DOCUMENT FINISH
      if (this.isUpdateDocumentFinish(nextProps)) {
        this.getDataFromServer(nextProps);
        this.props.onPutDocumentFinish(nextProps.queryStatus);
      }
    }
  }, {
    key: 'isGetFinish',
    value: function isGetFinish(nextProps) {
      if (this.props.queryStatus === LOADING && nextProps.queryStatus !== LOADING && (this.getDataFromServerIsRun || this.isDataChanged(nextProps))) {
        return true;
      }
      return false;
    }
  }, {
    key: 'isDeleteDocumentFinish',
    value: function isDeleteDocumentFinish(nextProps) {
      return this.props.queryStatus === CLOUD_CODE_DELETE_DOCUMENT_START && (nextProps.queryStatus === CLOUD_CODE_DELETE_DOCUMENT_SUCCESS || nextProps.queryStatus === CLOUD_CODE_DELETE_DOCUMENT_ERROR);
    }
  }, {
    key: 'isUpdateDocumentFinish',
    value: function isUpdateDocumentFinish(nextProps) {
      return this.props.queryStatus === CLOUD_CODE_UPDATE_DOCUMENT_START && (nextProps.queryStatus === CLOUD_CODE_UPDATE_DOCUMENT_SUCCESS || nextProps.queryStatus === CLOUD_CODE_UPDATE_DOCUMENT_ERROR);
    }
  }, {
    key: 'isDataChanged',
    value: function isDataChanged(nextProps) {
      return this.props.data !== nextProps.data;
    }
  }, {
    key: 'isQueryStatusChanged',
    value: function isQueryStatusChanged(nextProps) {
      return this.props.queryStatus !== nextProps.queryStatus;
    }
  }, {
    key: 'isPropsFromParentChanged',
    value: function isPropsFromParentChanged(nextProps) {
      // filters was change, get data from server
      if (this.isParamsChanged(nextProps)) {
        return true;
      }
      // functionName was change, get data from server
      if (this.props.functionName !== nextProps.functionName) {
        return true;
      }
      return false;
    }
  }, {
    key: 'isDataExistOrQueryIsLoading',
    value: function isDataExistOrQueryIsLoading() {
      var _props2 = this.props;
      var queryStatus = _props2.queryStatus;
      var data = _props2.data;

      if (data || queryStatus === LOADING) {
        return true;
      }
      return false;
    }

    // Clean data on Mount
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this.props.cleanDataOnComponentWillUnmount) {
        this.removerDataFromStore();
      }
    }
  }, {
    key: 'removerDataFromStore',
    value: function removerDataFromStore() {
      var keyForData = this.props.collectionTarget || this.props.functionName;
      this.props.actions.removeCloudCodeDataByTargetNameFromStore(keyForData);
    }

    // shouldComponentUpdate (nextProps, nextState) {
    //   if(this.isDataChanged(nextProps) || this.isQueryStatusChanged(nextProps) || this.isPropsFromParentChanged(nextProps)) {
    //     return true
    //   }
    //   return false
    // }
  }, {
    key: 'onDeleteDocument',
    value: function onDeleteDocument(objectId) {
      // DELETE document from collection
      if (!objectId) {
        console.warn('onDeleteDocument: missing objectId ');return;
      }
      if (this.props.queryStatus === _reduxConsts2['default'].COLLECTION_DELETE_DOCUMENT_START) return;
      this.props.onDeleteDocumentStart(objectId);
      console.warn('IN PROCESS');
      //this.props.actions.deleteDocumentFromCollectionOnServer(this.props.functionName, this.props.collectionTarget, objectId)
    }
  }, {
    key: 'onUpdateDocument',
    value: function onUpdateDocument(objectId, data) {
      if (!objectId) {
        console.warn('onUpdateDocument: missing objectId ');return;
      }
      if (!data || typeof data !== 'object') {
        console.warn('onUpdateDocument: missing data object ');return;
      }
      this.props.onPutDocumentStart(objectId);
      console.warn('IN PROCESS');
      //this.props.actions.updateDocumentFromCollectionOnServer(this.props.functionName, this.props.targetName, objectId, data)
    }
  }, {
    key: 'isParamsChanged',
    value: function isParamsChanged(nextProps) {
      return !(0, _lodashIsEqual2['default'])(this.props.params, nextProps.params);
    }
  }, {
    key: 'onRefreshData',
    value: function onRefreshData() {
      this.getDataFromServer(this.props, false);
    }
  }, {
    key: 'render',
    value: function render() {
      var data = this.props.data;
      var queryStatus = this.props.queryStatus;
      var count = this.props.count;
      var deleteDocument = this.onDeleteDocument;
      var updateDocument = this.onUpdateDocument;
      var refreshData = this.onRefreshData;
      return this.props.render({ data: data, queryStatus: queryStatus, count: count, refreshData: refreshData, deleteDocument: deleteDocument, updateDocument: updateDocument });
    }
  }]);

  return FetchCloudCode;
})(_react2['default'].PureComponent);

function mapStateToProps(state, props) {
  var keyForData = props.collectionTarget || props.functionName;
  return {
    data: (0, _reduxParseSelectors.getCloudCodeByTargetName)(state, keyForData),
    queryStatus: (0, _reduxParseSelectors.getCloudCodeQueryStatusByTargetName)(state, keyForData)
  };
}

function mapDispatchToProps(dispatch) {
  return {
    actions: (0, _redux.bindActionCreators)(_extends({}, parseActions), dispatch)
  };
}
exports['default'] = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(FetchCloudCode);

FetchCloudCode.propTypes = {
  functionName: _propTypes2['default'].string.isRequired,
  collectionTarget: _propTypes2['default'].string,
  render: _propTypes2['default'].func.isRequired, // render({data, queryStatus, refreshData, deleteDocument, updateDocument})
  params: _propTypes2['default'].object,
  onGetStart: _propTypes2['default'].func,
  onGetFinish: _propTypes2['default'].func,
  onDeleteDocumentStart: _propTypes2['default'].func,
  onDeleteDocumentFinish: _propTypes2['default'].func,
  onPutDocumentStart: _propTypes2['default'].func,
  onPutDocumentFinish: _propTypes2['default'].func,
  filterByMemberId: _propTypes2['default'].bool,
  cleanDataOnComponentWillUnmount: _propTypes2['default'].bool,
  localFirst: _propTypes2['default'].bool, // get data from server only if data didn't found in store
  localOnly: _propTypes2['default'].bool, // get data only from local store
  memberFieldName: _propTypes2['default'].string,
  digToDataString: _propTypes2['default'].string
};

FetchCloudCode.defaultProps = {
  memberFieldName: 'member',
  digToDataString: 'data.result',
  cleanDataOnComponentWillUnmount: true,
  onGetFinish: function onGetFinish() {
    console.log('onGetFinish');
  },
  onGetStart: function onGetStart() {
    console.log('onGetStart');
  },
  onDeleteDocumentStart: function onDeleteDocumentStart() {
    console.log('onDeleteDocumentStart');
  },
  onDeleteDocumentFinish: function onDeleteDocumentFinish() {
    console.log('onDeleteDocumentFinish');
  },
  onPutDocumentStart: function onPutDocumentStart() {
    console.log('onPutDocumentStart');
  },
  onPutDocumentFinish: function onPutDocumentFinish() {
    console.log('onPutDocumentFinish');
  }

};
module.exports = exports['default'];