'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x3, _x4, _x5) { var _again = true; _function: while (_again) { var object = _x3, property = _x4, receiver = _x5; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x3 = parent; _x4 = property; _x5 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRedux = require('react-redux');

var _redux = require('redux');

var _reduxActions = require('./redux/actions');

var parseActions = _interopRequireWildcard(_reduxActions);

var _reduxConsts = require('./redux/consts');

var _reduxConsts2 = _interopRequireDefault(_reduxConsts);

var _reduxParseSelectors = require('./redux/parseSelectors');

var _lodashIsEqual = require('lodash/isEqual');

var _lodashIsEqual2 = _interopRequireDefault(_lodashIsEqual);

var LOADING = _reduxConsts2['default'].LOADING;
var COLLECTION_DELETE_DOCUMENT_START = _reduxConsts2['default'].COLLECTION_DELETE_DOCUMENT_START;
var COLLECTION_DELETE_DOCUMENT_SUCCESS = _reduxConsts2['default'].COLLECTION_DELETE_DOCUMENT_SUCCESS;
var COLLECTION_DELETE_DOCUMENT_ERROR = _reduxConsts2['default'].COLLECTION_DELETE_DOCUMENT_ERROR;
var COLLECTION_UPDATE_DOCUMENT_START = _reduxConsts2['default'].COLLECTION_UPDATE_DOCUMENT_START;
var COLLECTION_UPDATE_DOCUMENT_SUCCESS = _reduxConsts2['default'].COLLECTION_UPDATE_DOCUMENT_SUCCESS;
var COLLECTION_UPDATE_DOCUMENT_ERROR = _reduxConsts2['default'].COLLECTION_UPDATE_DOCUMENT_ERROR;

var FetchCollection = (function (_React$PureComponent) {
  _inherits(FetchCollection, _React$PureComponent);

  function FetchCollection(props) {
    _classCallCheck(this, FetchCollection);

    _get(Object.getPrototypeOf(FetchCollection.prototype), 'constructor', this).call(this, props);
    this.getDataFromServerIsRun = false;
    this.getDataFromServer = this.getDataFromServer.bind(this);
    this.onDeleteDocument = this.onDeleteDocument.bind(this);
    this.onUpdateDocument = this.onUpdateDocument.bind(this);
    this.onRefreshData = this.onRefreshData.bind(this);
  }

  _createClass(FetchCollection, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _props = this.props;
      var localFirst = _props.localFirst;
      var collectionName = _props.collectionName;

      if (collectionName && (!localFirst || !this.isDataExistOrQueryIsLoading())) {
        this.getDataFromServer();
      }
    }
  }, {
    key: 'getDataFromServer',
    value: function getDataFromServer() {
      var props = arguments.length <= 0 || arguments[0] === undefined ? this.props : arguments[0];
      var localOnly = arguments.length <= 1 || arguments[1] === undefined ? this.props.localOnly : arguments[1];

      if (localOnly) return;
      var collectionName = props.collectionName;
      var collectionTarget = props.collectionTarget;
      var queryFilter = props.queryFilter;
      var perPage = props.perPage;
      var page = props.page;
      var include = props.include;
      var filterByMemberId = props.filterByMemberId;
      var keys = props.keys;
      var EnableCount = props.EnableCount;
      var memberFieldName = props.memberFieldName;

      if (!collectionName) return;
      this.getDataFromServerIsRun = true;
      this.props.onGetStart();
      this.props.actions.getCollectionByClassName(collectionName, collectionTarget, queryFilter, perPage, page, include, filterByMemberId, keys, EnableCount, memberFieldName);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      // Params from parent was changed
      if (this.isParamsChanged(nextProps)) {
        this.getDataFromServer(nextProps);
      }
      // GET DATA FINISH
      if (this.isGetFinish(nextProps)) {
        this.getDataFromServerIsRun = false;
        this.props.onGetFinish({ queryStatus: nextProps.queryStatus, data: nextProps.data, count: nextProps.count });
      }
      // DELETE DOCUMENT FINISH
      if (this.isDeleteDocumentFinish(nextProps)) {
        this.getDataFromServer(nextProps);
        this.props.onDeleteDocumentFinish(nextProps.queryStatus);
      }
      // UPDATE DOCUMENT FINISH
      if (this.isUpdateDocumentFinish(nextProps)) {
        this.getDataFromServer(nextProps);
        this.props.onPutDocumentFinish(nextProps.queryStatus);
      }
    }
  }, {
    key: 'isGetFinish',
    value: function isGetFinish(nextProps) {
      if (this.props.queryStatus === LOADING && nextProps.queryStatus !== LOADING && (this.getDataFromServerIsRun || this.isDataChanged(nextProps))) {
        return true;
      }
      return false;
    }
  }, {
    key: 'isDeleteDocumentFinish',
    value: function isDeleteDocumentFinish(nextProps) {
      return this.props.queryStatus === COLLECTION_DELETE_DOCUMENT_START && (nextProps.queryStatus === COLLECTION_DELETE_DOCUMENT_SUCCESS || nextProps.queryStatus === COLLECTION_DELETE_DOCUMENT_ERROR);
    }
  }, {
    key: 'isUpdateDocumentFinish',
    value: function isUpdateDocumentFinish(nextProps) {
      return this.props.queryStatus === COLLECTION_UPDATE_DOCUMENT_START && (nextProps.queryStatus === COLLECTION_UPDATE_DOCUMENT_SUCCESS || nextProps.queryStatus === COLLECTION_UPDATE_DOCUMENT_ERROR);
    }
  }, {
    key: 'isDataChanged',
    value: function isDataChanged(nextProps) {
      return this.props.data !== nextProps.data;
    }
  }, {
    key: 'isQueryStatusChanged',
    value: function isQueryStatusChanged(nextProps) {
      return this.props.queryStatus !== nextProps.queryStatus;
    }
  }, {
    key: 'isParamsChanged',
    value: function isParamsChanged(nextProps) {
      // filters was change, get data from server
      if (this.isQueryFilterChanged(nextProps)) {
        return true;
      }
      // page was change, get data from server
      if (this.props.page !== nextProps.page) {
        return true;
      }
      // collectionName was change, get data from server
      if (this.props.collectionName !== nextProps.collectionName) {
        return true;
      }
      // key was change, get data from server
      if (this.props.key !== nextProps.key) {
        return true;
      }
      return false;
    }
  }, {
    key: 'isDataExistOrQueryIsLoading',
    value: function isDataExistOrQueryIsLoading() {
      var _props2 = this.props;
      var queryStatus = _props2.queryStatus;
      var data = _props2.data;

      if (data || queryStatus === LOADING) {
        return true;
      }
      return false;
    }

    // Clean data on Mount
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this.props.cleanDataOnComponentWillUnmount) {
        this.removerDataFromStore();
      }
    }
  }, {
    key: 'removerDataFromStore',
    value: function removerDataFromStore() {
      var keyForData = this.props.collectionTarget || this.props.collectionName;
      this.props.actions.removeCollectionByTargetNameFromStore(keyForData);
    }

    // shouldComponentUpdate (nextProps, nextState) {
    //   if(this.isDataChanged(nextProps) || this.isQueryStatusChanged(nextProps) || this.isParamsChanged(nextProps)) {
    //     return true
    //   }
    //   return false
    // }
  }, {
    key: 'onDeleteDocument',
    value: function onDeleteDocument(objectId) {
      // DELETE document from collection
      if (!objectId) {
        console.warn('onDeleteDocument: missing objectId ');return;
      }
      if (this.props.queryStatus === _reduxConsts2['default'].COLLECTION_DELETE_DOCUMENT_START) return;
      this.props.onDeleteDocumentStart(objectId);
      this.props.actions.deleteDocumentFromCollectionOnServer(this.props.collectionName, this.props.collectionTarget, objectId);
    }
  }, {
    key: 'onUpdateDocument',
    value: function onUpdateDocument(objectId, data) {
      if (!objectId) {
        console.warn('onUpdateDocument: missing objectId ');return;
      }
      if (!data || typeof data !== 'object') {
        console.warn('onUpdateDocument: missing data object ');return;
      }
      this.props.onPutDocumentStart(objectId);
      this.props.actions.updateDocumentFromCollectionOnServer(this.props.collectionName, this.props.targetName, objectId, data);
    }
  }, {
    key: 'isQueryFilterChanged',
    value: function isQueryFilterChanged(nextProps) {
      return !(0, _lodashIsEqual2['default'])(this.props.queryFilter, nextProps.queryFilter);
    }
  }, {
    key: 'onRefreshData',
    value: function onRefreshData() {
      this.getDataFromServer(this.props, false);
    }
  }, {
    key: 'render',
    value: function render() {
      var data = this.props.data;
      var queryStatus = this.props.queryStatus;
      var count = this.props.count;
      var deleteDocument = this.onDeleteDocument;
      var updateDocument = this.onUpdateDocument;
      var refreshData = this.onRefreshData;
      return this.props.render({ data: data, queryStatus: queryStatus, count: count, refreshData: refreshData, deleteDocument: deleteDocument, updateDocument: updateDocument });
    }
  }]);

  return FetchCollection;
})(_react2['default'].PureComponent);

function mapStateToProps(state, props) {
  var keyForData = props.collectionTarget || props.collectionName;
  return {
    data: (0, _reduxParseSelectors.getCollectionByTargetName)(state, keyForData),
    queryStatus: (0, _reduxParseSelectors.getCollectionQueryStatusByTargetName)(state, keyForData),
    count: (0, _reduxParseSelectors.getCountByTargetName)(state, keyForData)
  };
}

function mapDispatchToProps(dispatch) {
  return {
    actions: (0, _redux.bindActionCreators)(_extends({}, parseActions), dispatch)
  };
}
exports['default'] = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(FetchCollection);

FetchCollection.propTypes = {
  collectionName: _propTypes2['default'].string.isRequired,
  collectionTarget: _propTypes2['default'].string,
  render: _propTypes2['default'].func.isRequired, // render({data, queryStatus, refreshData, deleteDocument, updateDocument})
  queryFilter: _propTypes2['default'].object,
  include: _propTypes2['default'].string,
  keys: _propTypes2['default'].string,
  perPage: _propTypes2['default'].number,
  page: _propTypes2['default'].number,
  EnableCount: _propTypes2['default'].bool,
  onGetStart: _propTypes2['default'].func,
  onGetFinish: _propTypes2['default'].func,
  onDeleteDocumentStart: _propTypes2['default'].func,
  onDeleteDocumentFinish: _propTypes2['default'].func,
  onPutDocumentStart: _propTypes2['default'].func,
  onPutDocumentFinish: _propTypes2['default'].func,
  filterByMemberId: _propTypes2['default'].bool,
  cleanDataOnComponentWillUnmount: _propTypes2['default'].bool,
  localFirst: _propTypes2['default'].bool, // get data from server only if data didn't found in store
  localOnly: _propTypes2['default'].bool, // get data only from local store
  memberFieldName: _propTypes2['default'].string
};

FetchCollection.defaultProps = {
  perPage: 25,
  memberFieldName: 'member',
  EnableCount: false,
  cleanDataOnComponentWillUnmount: true,
  onGetFinish: function onGetFinish() {
    console.log('onGetFinish');
  },
  onGetStart: function onGetStart() {
    console.log('onGetStart');
  },
  onDeleteDocumentStart: function onDeleteDocumentStart() {
    console.log('onDeleteDocumentStart');
  },
  onDeleteDocumentFinish: function onDeleteDocumentFinish() {
    console.log('onDeleteDocumentFinish');
  },
  onPutDocumentStart: function onPutDocumentStart() {
    console.log('onPutDocumentStart');
  },
  onPutDocumentFinish: function onPutDocumentFinish() {
    console.log('onPutDocumentFinish');
  }

};
module.exports = exports['default'];