'use strict';
Object.defineProperty(exports, '__esModule', {
  value: true
});

var _reselect = require('reselect');

var _immutable = require('immutable');

// import moment from 'moment'
// import * as helpers from 'src/logic/tools/charm-helpers'

// --- Collections ---/
var getTargetName = function getTargetName(state, targetName) {
  return targetName;
};
exports.getTargetName = getTargetName;
// Data
//---------------------------
// -- Get all collections
var getCollections = function getCollections(state) {
  return state.parse.collections;
};
exports.getCollections = getCollections;
// -- Get specific collections
var getCollectionByTargetName = (0, _reselect.createSelector)([getCollections, getTargetName], function (collections, targetName) {
  var dataImmutable = collections.get(targetName);
  if (_immutable.Iterable.isIterable(dataImmutable)) return dataImmutable.toJS();
  return null;
});
exports.getCollectionByTargetName = getCollectionByTargetName;
// Query Status
//---------------------------
// -- Get all collections query Status
var getCollectionsQueryStatus = function getCollectionsQueryStatus(state) {
  return state.parse.collectionsQueryStatus;
};
exports.getCollectionsQueryStatus = getCollectionsQueryStatus;
// -- Get specific collections query Status
var getCollectionQueryStatusByTargetName = (0, _reselect.createSelector)([getCollectionsQueryStatus, getTargetName], function (collectionsQueryStatus, targetName) {
  return collectionsQueryStatus.get(targetName);
});
exports.getCollectionQueryStatusByTargetName = getCollectionQueryStatusByTargetName;
// Count
//---------------------------
// -- Get all collections Count
var getCollectionsCount = function getCollectionsCount(state) {
  return state.parse.collectionsCount;
};
exports.getCollectionsCount = getCollectionsCount;
// -- Get specific collections Count
var getCountByTargetName = (0, _reselect.createSelector)([getCollectionsCount, getTargetName], function (collectionsCount, targetName) {
  return collectionsCount.get(targetName);
});

exports.getCountByTargetName = getCountByTargetName;
// --- Documents ---/
var getObjectId = function getObjectId(state, objectId) {
  return objectId;
};
exports.getObjectId = getObjectId;
var getUniqueId = function getUniqueId(state, uniqueId) {
  return uniqueId;
};
exports.getUniqueId = getUniqueId;
// -- Get all documents by objectId
var getDocumentsByObjectId = function getDocumentsByObjectId(state) {
  return state.parse.documentsByObjectId;
};
exports.getDocumentsByObjectId = getDocumentsByObjectId;
// -- Get specific document by objectId
var getDocumentByObjectId = (0, _reselect.createSelector)([getDocumentsByObjectId, getObjectId], function (documentsByObjectId, objectId) {
  var dataImmutable = documentsByObjectId.get(objectId);
  if (_immutable.Iterable.isIterable(dataImmutable)) return dataImmutable.toJS();
  return null;
});
exports.getDocumentByObjectId = getDocumentByObjectId;
// -- Get all documents by uniqueId
var getDocumentsByUniqueId = function getDocumentsByUniqueId(state) {
  return state.parse.documentsByUniqueId;
};
exports.getDocumentsByUniqueId = getDocumentsByUniqueId;
// -- Get specific document by objectId
var getDocumentByUniqueId = (0, _reselect.createSelector)([getDocumentsByUniqueId, getUniqueId], function (documentsByUniqueId, uniqueId) {
  var dataImmutable = documentsByUniqueId.get(uniqueId);
  if (_immutable.Iterable.isIterable(dataImmutable)) return dataImmutable.toJS();
  return null;
});
exports.getDocumentByUniqueId = getDocumentByUniqueId;
// Query Status
//---------------------------
// -- Get all documentsByObjectId query Status
var getDocumentsQueryStatusByObjectId = function getDocumentsQueryStatusByObjectId(state) {
  return state.parse.documentsByObjectIdQueryStatus;
};
exports.getDocumentsQueryStatusByObjectId = getDocumentsQueryStatusByObjectId;
// -- Get specific collections query Status
var getDocumentQueryStatusByObjectId = (0, _reselect.createSelector)([getDocumentsQueryStatusByObjectId, getObjectId], function (documentByObjectIdQueryStatus, objectId) {
  return documentByObjectIdQueryStatus.get(objectId);
});
exports.getDocumentQueryStatusByObjectId = getDocumentQueryStatusByObjectId;
// -- Get all documentsByObjectId query Status
var getDocumentsQueryStatusByUniqueId = function getDocumentsQueryStatusByUniqueId(state) {
  return state.parse.documentsByUniqueIdQueryStatus;
};
exports.getDocumentsQueryStatusByUniqueId = getDocumentsQueryStatusByUniqueId;
// -- Get specific collections query Status
var getDocumentQueryStatusByUniqueId = (0, _reselect.createSelector)([getDocumentsQueryStatusByUniqueId, getUniqueId], function (documentsQueryStatusByUniqueId, uniqueId) {
  var dataImmutable = documentsQueryStatusByUniqueId.get(uniqueId);
  if (_immutable.Iterable.isIterable(dataImmutable)) return dataImmutable.toJS();
  return null;
});
exports.getDocumentQueryStatusByUniqueId = getDocumentQueryStatusByUniqueId;
// --- Cloud codes ---/
// Data
//---------------------------
// -- Get all collections
var getCloudCodes = function getCloudCodes(state) {
  return state.parse.cloudCodes;
};
exports.getCloudCodes = getCloudCodes;
// -- Get specific collections
var getCloudCodeByTargetName = (0, _reselect.createSelector)([getCloudCodes, getTargetName], function (clodCodes, targetName) {
  var dataImmutable = clodCodes.get(targetName);
  if (_immutable.Iterable.isIterable(dataImmutable)) return dataImmutable.toJS();
  return null;
});
exports.getCloudCodeByTargetName = getCloudCodeByTargetName;
// Query Status
//---------------------------
// -- Get all collections query Status
var getCloudCodesQueryStatus = function getCloudCodesQueryStatus(state) {
  return state.parse.cloudCodesQueryStatus;
};
exports.getCloudCodesQueryStatus = getCloudCodesQueryStatus;
// -- Get specific collections query Status
var getCloudCodeQueryStatusByTargetName = (0, _reselect.createSelector)([getCloudCodesQueryStatus, getTargetName], function (cloudCodesQueryStatus, targetName) {
  return cloudCodesQueryStatus.get(targetName);
});
exports.getCloudCodeQueryStatusByTargetName = getCloudCodeQueryStatusByTargetName;
// Count
//---------------------------
// -- Get all collections Count
var getCloudCodesCount = function getCloudCodesCount(state) {
  return state.parse.cloudCodesCount;
};
exports.getCloudCodesCount = getCloudCodesCount;
// -- Get specific collections Count
var getCloudCodeCountByTargetName = (0, _reselect.createSelector)([getCloudCodesCount, getTargetName], function (cloudCodesCount, targetName) {
  return cloudCodesCount.get(targetName);
});
exports.getCloudCodeCountByTargetName = getCloudCodeCountByTargetName;