/**
 * # redux > market > sagaWatcher.js
 *
 * This file contain all market Watcher
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var marked0$0 = [componentsWatcher].map(regeneratorRuntime.mark);

var _reduxSagaEffects = require('redux-saga/effects');

// Import all the ActionTypes

var _types = require('./types');

var _types2 = _interopRequireDefault(_types);

// Import all workers from Workers Folder
// Collections

var _sagaWorkersGetCollectionByClassNameWorker = require('../sagaWorkers/getCollectionByClassNameWorker');

var _sagaWorkersGetCollectionByClassNameWorker2 = _interopRequireDefault(_sagaWorkersGetCollectionByClassNameWorker);

var _sagaWorkersDeleteDocumentFromCollectionOnServerWorker = require('../sagaWorkers/deleteDocumentFromCollectionOnServerWorker');

var _sagaWorkersDeleteDocumentFromCollectionOnServerWorker2 = _interopRequireDefault(_sagaWorkersDeleteDocumentFromCollectionOnServerWorker);

var _sagaWorkersUpdateDocumentFromCollectionOnServerWorker = require('../sagaWorkers/updateDocumentFromCollectionOnServerWorker');

var _sagaWorkersUpdateDocumentFromCollectionOnServerWorker2 = _interopRequireDefault(_sagaWorkersUpdateDocumentFromCollectionOnServerWorker);

// Documents

var _sagaWorkersGetDocumentByObjectIdWorker = require('../sagaWorkers/getDocumentByObjectIdWorker');

var _sagaWorkersGetDocumentByObjectIdWorker2 = _interopRequireDefault(_sagaWorkersGetDocumentByObjectIdWorker);

var _sagaWorkersUpdateDocumentOnServerByObjectIdWorker = require('../sagaWorkers/updateDocumentOnServerByObjectIdWorker');

var _sagaWorkersUpdateDocumentOnServerByObjectIdWorker2 = _interopRequireDefault(_sagaWorkersUpdateDocumentOnServerByObjectIdWorker);

var _sagaWorkersDeleteDocumentFromServerWorker = require('../sagaWorkers/deleteDocumentFromServerWorker');

var _sagaWorkersDeleteDocumentFromServerWorker2 = _interopRequireDefault(_sagaWorkersDeleteDocumentFromServerWorker);

var _sagaWorkersPostLocalDocumentByUniqueIdToServerWorker = require('../sagaWorkers/postLocalDocumentByUniqueIdToServerWorker');

var _sagaWorkersPostLocalDocumentByUniqueIdToServerWorker2 = _interopRequireDefault(_sagaWorkersPostLocalDocumentByUniqueIdToServerWorker);

// Cloud Codes

var _sagaWorkersGetDataByCloudCodeNameWorker = require('../sagaWorkers/getDataByCloudCodeNameWorker');

var _sagaWorkersGetDataByCloudCodeNameWorker2 = _interopRequireDefault(_sagaWorkersGetDataByCloudCodeNameWorker);

// all market watchers
function componentsWatcher() {
  return regeneratorRuntime.wrap(function componentsWatcher$(context$1$0) {
    while (1) switch (context$1$0.prev = context$1$0.next) {
      case 0:
        context$1$0.next = 2;
        return (0, _reduxSagaEffects.takeEvery)(_types2['default'].GET_COLLECTION_BY_CLASS_NAME, _sagaWorkersGetCollectionByClassNameWorker2['default']);

      case 2:
        context$1$0.next = 4;
        return (0, _reduxSagaEffects.takeEvery)(_types2['default'].DELETE_DOCUMENT_FROM_COLLECTION_ON_SERVER, _sagaWorkersDeleteDocumentFromCollectionOnServerWorker2['default']);

      case 4:
        context$1$0.next = 6;
        return (0, _reduxSagaEffects.takeEvery)(_types2['default'].UPDATE_DOCUMENT_FROM_COLLECTION_ON_SERVER, _sagaWorkersUpdateDocumentFromCollectionOnServerWorker2['default']);

      case 6:
        context$1$0.next = 8;
        return (0, _reduxSagaEffects.takeEvery)(_types2['default'].GET_DOCUMENT_BY_OBJECT_ID, _sagaWorkersGetDocumentByObjectIdWorker2['default']);

      case 8:
        context$1$0.next = 10;
        return (0, _reduxSagaEffects.takeEvery)(_types2['default'].UPDATE_DOCUMENT_ON_SERVER_BY_OBJECT_ID, _sagaWorkersUpdateDocumentOnServerByObjectIdWorker2['default']);

      case 10:
        context$1$0.next = 12;
        return (0, _reduxSagaEffects.takeEvery)(_types2['default'].DELETE_DOCUMENT_FROM_SERVER_BY_OBJECT_ID, _sagaWorkersDeleteDocumentFromServerWorker2['default']);

      case 12:
        context$1$0.next = 14;
        return (0, _reduxSagaEffects.takeEvery)(_types2['default'].POST_LOCAL_DOCUMENT_BY_UNIQUE_ID_TO_SERVER, _sagaWorkersPostLocalDocumentByUniqueIdToServerWorker2['default']);

      case 14:
        context$1$0.next = 16;
        return (0, _reduxSagaEffects.takeEvery)(_types2['default'].GET_DATA_BY_CLOUD_CODE_NAME, _sagaWorkersGetDataByCloudCodeNameWorker2['default']);

      case 16:
      case 'end':
        return context$1$0.stop();
    }
  }, marked0$0[0], this);
}

exports['default'] = componentsWatcher;
module.exports = exports['default'];

// put,
// call,
// select,
// delay,
// take,
// takeLatest,
// throttle,

// Collections

// Documents

// Cloud code