'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = deleteDocumentFromCollectionOnServerWorker;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var marked0$0 = [deleteDocumentFromCollectionOnServerWorker].map(regeneratorRuntime.mark);

var _reduxSagaEffects = require('redux-saga/effects');

var _serverApiSagaWrapper = require('../../server/apiSagaWrapper');

var _reduxTypes = require('../redux/types');

var _reduxTypes2 = _interopRequireDefault(_reduxTypes);

var _reduxConsts = require('../redux/consts');

var _reduxConsts2 = _interopRequireDefault(_reduxConsts);

var _serverApi = require('../../server/api');

var _serverApi2 = _interopRequireDefault(_serverApi);

var COLLECTION_DELETE_DOCUMENT_START = _reduxConsts2['default'].COLLECTION_DELETE_DOCUMENT_START;
var COLLECTION_DELETE_DOCUMENT_ERROR = _reduxConsts2['default'].COLLECTION_DELETE_DOCUMENT_ERROR;
var NETWORK_ERROR = _reduxConsts2['default'].NETWORK_ERROR;
var SUCCESS = _reduxConsts2['default'].SUCCESS;
var COLLECTION_DELETE_DOCUMENT_SUCCESS = _reduxConsts2['default'].COLLECTION_DELETE_DOCUMENT_SUCCESS;

function deleteDocumentFromCollectionOnServerWorker(action) {
  var className, targetName, objectId, res;
  return regeneratorRuntime.wrap(function deleteDocumentFromCollectionOnServerWorker$(context$1$0) {
    while (1) switch (context$1$0.prev = context$1$0.next) {
      case 0:
        className = action.className;
        targetName = action.targetName;
        objectId = action.objectId;
        context$1$0.next = 5;
        return (0, _reduxSagaEffects.put)({ type: _reduxTypes2['default'].SET_REQUEST_STATUS_BY_TARGET_NAME, targetName: targetName || className, status: COLLECTION_DELETE_DOCUMENT_START });

      case 5:
        return context$1$0.delegateYield((0, _serverApiSagaWrapper.httpRequest)(_serverApi2['default'].deleteObject, className, objectId), 't0', 6);

      case 6:
        res = context$1$0.t0;

        if (!res.error) {
          context$1$0.next = 14;
          break;
        }

        context$1$0.next = 10;
        return (0, _reduxSagaEffects.put)({
          type: _reduxTypes2['default'].SET_REQUEST_STATUS_BY_TARGET_NAME,
          targetName: targetName || className,
          status: COLLECTION_DELETE_DOCUMENT_ERROR
        });

      case 10:
        context$1$0.next = 12;
        return (0, _reduxSagaEffects.put)({
          type: _reduxTypes2['default'].SET_REQUEST_STATUS_BY_TARGET_NAME,
          targetName: targetName || className,
          status: res.message === 'Network Error' ? NETWORK_ERROR : SUCCESS });

      case 12:
        context$1$0.next = 18;
        break;

      case 14:
        context$1$0.next = 16;
        return (0, _reduxSagaEffects.put)({
          type: _reduxTypes2['default'].SET_REQUEST_STATUS_BY_TARGET_NAME,
          targetName: targetName || className,
          status: COLLECTION_DELETE_DOCUMENT_SUCCESS
        });

      case 16:
        context$1$0.next = 18;
        return (0, _reduxSagaEffects.put)({
          type: _reduxTypes2['default'].SET_REQUEST_STATUS_BY_TARGET_NAME,
          targetName: targetName || className,
          status: SUCCESS });

      case 18:
      case 'end':
        return context$1$0.stop();
    }
  }, marked0$0[0], this);
}

// worker
module.exports = exports['default'];

// Second - run http Request with httpRequest wrapper that handle error

// Set query status to error
// the delete is only action of one of the all collection, back to success mode
// the delete is only action of one of the all collection, back to success mode