'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = deleteDocumentFromServerWorker;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var marked0$0 = [deleteDocumentFromServerWorker].map(regeneratorRuntime.mark);

var _reduxSagaEffects = require('redux-saga/effects');

var _serverApiSagaWrapper = require('../../server/apiSagaWrapper');

var _reduxTypes = require('../redux/types');

var _reduxTypes2 = _interopRequireDefault(_reduxTypes);

var _reduxConsts = require('../redux/consts');

var _reduxConsts2 = _interopRequireDefault(_reduxConsts);

var _serverApi = require('../../server/api');

var _serverApi2 = _interopRequireDefault(_serverApi);

var _reduxActions = require('../redux/actions');

var DELETE_DOCUMENT_START = _reduxConsts2['default'].DELETE_DOCUMENT_START;
var DELETE_DOCUMENT_ERROR = _reduxConsts2['default'].DELETE_DOCUMENT_ERROR;
var ERROR = _reduxConsts2['default'].ERROR;
var DELETE_DOCUMENT_SUCCESS = _reduxConsts2['default'].DELETE_DOCUMENT_SUCCESS;
var NETWORK_ERROR = _reduxConsts2['default'].NETWORK_ERROR;

function deleteDocumentFromServerWorker(action) {
  var className, objectId, res;
  return regeneratorRuntime.wrap(function deleteDocumentFromServerWorker$(context$1$0) {
    while (1) switch (context$1$0.prev = context$1$0.next) {
      case 0:
        className = action.className;
        objectId = action.objectId;
        context$1$0.next = 4;
        return (0, _reduxSagaEffects.put)({
          type: _reduxTypes2['default'].SET_REQUEST_STATUS_BY_OBJECT_ID,
          objectId: objectId,
          status: DELETE_DOCUMENT_START
        });

      case 4:
        return context$1$0.delegateYield((0, _serverApiSagaWrapper.httpRequest)(_serverApi2['default'].deleteObject, className, objectId), 't0', 5);

      case 5:
        res = context$1$0.t0;

        if (!res.error) {
          context$1$0.next = 13;
          break;
        }

        context$1$0.next = 9;
        return (0, _reduxSagaEffects.put)({
          type: _reduxTypes2['default'].SET_REQUEST_STATUS_BY_OBJECT_ID,
          objectId: objectId,
          status: DELETE_DOCUMENT_ERROR
        });

      case 9:
        context$1$0.next = 11;
        return (0, _reduxSagaEffects.put)({
          type: _reduxTypes2['default'].SET_REQUEST_STATUS_BY_OBJECT_ID,
          objectId: objectId,
          status: res.message === 'Network Error' ? NETWORK_ERROR : ERROR
        });

      case 11:
        context$1$0.next = 17;
        break;

      case 13:
        context$1$0.next = 15;
        return (0, _reduxSagaEffects.put)(_reduxActions.removeLocalDocumentByObjectId, objectId);

      case 15:
        context$1$0.next = 17;
        return (0, _reduxSagaEffects.put)({
          type: _reduxTypes2['default'].SET_REQUEST_STATUS_BY_OBJECT_ID,
          objectId: objectId,
          status: DELETE_DOCUMENT_SUCCESS
        });

      case 17:
      case 'end':
        return context$1$0.stop();
    }
  }, marked0$0[0], this);
}

// worker
module.exports = exports['default'];