/**
 * # redux > market > sagaWorkers > getCollectionByClassNameWorker.js
 *
 * market Worker
 */

/* eslint no-console: ["error", { allow: ["warn", "error"] }] */
/**
 * Project requirements
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = getCollectionByClassNameWorker;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var marked0$0 = [getCollectionByClassNameWorker].map(regeneratorRuntime.mark);

var _reduxSagaEffects = require('redux-saga/effects');

// import {Actions} from 'react-native-router-flux'
// const _ = require('lodash')

var _serverApiSagaWrapper = require('../../server/apiSagaWrapper');

var _reduxTypes = require('../redux/types');

var _reduxTypes2 = _interopRequireDefault(_reduxTypes);

var _reduxConsts = require('../redux/consts');

var _reduxConsts2 = _interopRequireDefault(_reduxConsts);

// import {getDataFromState} from '../reducer'

var _serverApi = require('../../server/api');

var _serverApi2 = _interopRequireDefault(_serverApi);

// this function call by sagaWatcher when user type new value in searchInput
var LOADING = _reduxConsts2['default'].LOADING;
var SUCCESS_WITH_ZERO_RESULTS = _reduxConsts2['default'].SUCCESS_WITH_ZERO_RESULTS;
var ERROR = _reduxConsts2['default'].ERROR;
var NETWORK_ERROR = _reduxConsts2['default'].NETWORK_ERROR;
var SUCCESS = _reduxConsts2['default'].SUCCESS;

function getCollectionByClassNameWorker(action) {
  var className, targetName, query, perPage, page, filterByMemberId, count, res, errType, data, _queryStatus;

  return regeneratorRuntime.wrap(function getCollectionByClassNameWorker$(context$1$0) {
    while (1) switch (context$1$0.prev = context$1$0.next) {
      case 0:
        className = action.className;
        targetName = action.targetName;
        query = action.query;
        perPage = action.perPage;
        page = action.page;
        filterByMemberId = action.filterByMemberId;
        count = action.count;
        context$1$0.next = 9;
        return (0, _reduxSagaEffects.put)({
          type: _reduxTypes2['default'].SET_REQUEST_STATUS_BY_TARGET_NAME,
          targetName: targetName || className,
          status: LOADING
        });

      case 9:
        // Second - run http Request with httpRequest wrapper that handle error
        // const res = yield * httpRequest(api.query, 'DummyDataCategoriesConfig', query, null, null, null, null, include, order) // Make the request
        if (filterByMemberId) {
          query = Object.assign({}, query);
          query[action.memberFieldName] = currentUser.memberId;
        }
        return context$1$0.delegateYield((0, _serverApiSagaWrapper.httpRequest)(_serverApi2['default'].query, className, query, perPage, perPage && page && page - 1 > 0 ? (page - 1) * perPage : null, // skip
        count, action.keys, action.include, '-createdAt'), 't0', 11);

      case 11:
        res = context$1$0.t0;

        if (!res.error) {
          context$1$0.next = 18;
          break;
        }

        errType = res.message === 'Network Error' ? NETWORK_ERROR : ERROR;
        context$1$0.next = 16;
        return (0, _reduxSagaEffects.put)({
          type: _reduxTypes2['default'].SET_REQUEST_STATUS_BY_TARGET_NAME,
          targetName: targetName || className,
          status: errType
        });

      case 16:
        context$1$0.next = 22;
        break;

      case 18:
        data = res.data.results ? res.data.results : [];
        _queryStatus = data.length > 0 ? SUCCESS : SUCCESS_WITH_ZERO_RESULTS;
        context$1$0.next = 22;
        return (0, _reduxSagaEffects.put)({ type: _reduxTypes2['default'].SET_COLLECTION_PARAMETERS, targetName: targetName || className, status: _queryStatus, data: data, count: res.data.count });

      case 22:
      case 'end':
        return context$1$0.stop();
    }
  }, marked0$0[0], this);
}

// worker
module.exports = exports['default'];

// takeEvery,

// call,
// Make the request
// Check For error

// Set query status to error

// Handle Success
// extricate data from server response

// data = data[0].categoryData
// set data to sate
// yield put({ type: types.SET_COLLECTION_BY_TARGET_NAME, targetName: targetName || className, data }); // set data to sate
// yield put({ type: types.SET_COUNT_BY_TARGET_NAME, targetName: targetName || className, count: res.data.count }); // set data.count to sate
// // Set query status - oneOf['SUCCESS','SUCCESS_WITH_ZERO_RESULTS]
// yield put({
//   type: types.SET_REQUEST_STATUS_BY_TARGET_NAME,
//   targetName: targetName || className,
//   status: _queryStatus,
// });