/**
 * # redux > market > sagaWorkers > getDataByCloudCodeNameWorker.js
 *
 * market Worker
 */

/* eslint no-console: ["error", { allow: ["warn", "error"] }] */
/**
 * Project requirements
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = getDataByCloudCodeNameWorker;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var marked0$0 = [getDataByCloudCodeNameWorker].map(regeneratorRuntime.mark);

var _reduxSagaEffects = require('redux-saga/effects');

// import {Actions} from 'react-native-router-flux'
// const _ = require('lodash')

var _serverApiSagaWrapper = require('../../server/apiSagaWrapper');

var _reduxTypes = require('../redux/types');

var _reduxTypes2 = _interopRequireDefault(_reduxTypes);

var _reduxConsts = require('../redux/consts');

var _reduxConsts2 = _interopRequireDefault(_reduxConsts);

// import {getDataFromState} from '../reducer'

var _serverApi = require('../../server/api');

var _serverApi2 = _interopRequireDefault(_serverApi);

var _helpers = require('../../helpers');

// this function call by sagaWatcher when user type new value in searchInput
var LOADING = _reduxConsts2['default'].LOADING;
var SUCCESS_WITH_ZERO_RESULTS = _reduxConsts2['default'].SUCCESS_WITH_ZERO_RESULTS;
var ERROR = _reduxConsts2['default'].ERROR;
var NETWORK_ERROR = _reduxConsts2['default'].NETWORK_ERROR;
var SUCCESS = _reduxConsts2['default'].SUCCESS;

function getDataByCloudCodeNameWorker(action) {
  var functionName, targetName, query, filterByMemberId, res, errType, data, _queryStatus;

  return regeneratorRuntime.wrap(function getDataByCloudCodeNameWorker$(context$1$0) {
    while (1) switch (context$1$0.prev = context$1$0.next) {
      case 0:
        functionName = action.functionName;
        targetName = action.targetName;
        query = action.query;
        filterByMemberId = action.filterByMemberId;
        context$1$0.next = 6;
        return (0, _reduxSagaEffects.put)({
          type: _reduxTypes2['default'].SET_CLOUD_CODE_REQUEST_STATUS_BY_TARGET_NAME,
          targetName: targetName || functionName,
          status: LOADING
        });

      case 6:
        // Second - run http Request with httpRequest wrapper that handle error
        // const res = yield * httpRequest(api.query, 'DummyDataCategoriesConfig', query, null, null, null, null, include, order) // Make the request
        if (filterByMemberId) {
          query = Object.assign({}, query);
          query[action.memberFieldName] = currentUser.memberId;
        }
        context$1$0.next = 9;
        return (0, _serverApiSagaWrapper.httpRequest)(_serverApi2['default'].getCloudFunction, functionName, query);

      case 9:
        res = context$1$0.sent;

        if (!res.error) {
          context$1$0.next = 16;
          break;
        }

        errType = res.message === 'Network Error' ? NETWORK_ERROR : ERROR;
        context$1$0.next = 14;
        return (0, _reduxSagaEffects.put)({
          type: _reduxTypes2['default'].SET_CLOUD_CODE_REQUEST_STATUS_BY_TARGET_NAME,
          targetName: targetName || functionName,
          status: errType
        });

      case 14:
        context$1$0.next = 20;
        break;

      case 16:
        data = (0, _helpers.dig)(res, action.digToDataString);
        _queryStatus = data.length > 0 ? SUCCESS : SUCCESS_WITH_ZERO_RESULTS;
        context$1$0.next = 20;
        return (0, _reduxSagaEffects.put)({ type: _reduxTypes2['default'].SET_CLOUD_CODE_PARAMETERS, targetName: targetName || functionName, status: _queryStatus, data: data, count: res.data.count });

      case 20:
      case 'end':
        return context$1$0.stop();
    }
  }, marked0$0[0], this);
}

// worker
module.exports = exports['default'];

// takeEvery,

// call,
// Make the request
// Check For error

// Set query status to error

// Handle Success
// extricate data from server response

// data = data[0].categoryData
// set data to sate
// yield put({ type: types.SET_COLLECTION_BY_TARGET_NAME, targetName: targetName || className, data }); // set data to sate
// yield put({ type: types.SET_COUNT_BY_TARGET_NAME, targetName: targetName || className, count: res.data.count }); // set data.count to sate
// // Set query status - oneOf['SUCCESS','SUCCESS_WITH_ZERO_RESULTS]
// yield put({
//   type: types.SET_CLOUD_CODE_REQUEST_STATUS_BY_TARGET_NAME,
//   targetName: targetName || className,
//   status: _queryStatus,
// });