/**
 * # redux > market > sagaWorkers > getDocumentByObjectIdWorker.js
 *
 * market Worker
 */

/* eslint no-console: ["error", { allow: ["warn", "error"] }] */
/**
 * Project requirements
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = getDocumentByObjectIdWorker;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var marked0$0 = [getDocumentByObjectIdWorker].map(regeneratorRuntime.mark);

var _reduxSagaEffects = require('redux-saga/effects');

// import {Actions} from 'react-native-router-flux'
// const _ = require('lodash')

var _serverApiSagaWrapper = require('../../server/apiSagaWrapper');

var _reduxTypes = require('../redux/types');

var _reduxTypes2 = _interopRequireDefault(_reduxTypes);

var _reduxConsts = require('../redux/consts');

var _reduxConsts2 = _interopRequireDefault(_reduxConsts);

// import {getDataFromState} from '../reducer'

var _serverApi = require('../../server/api');

var _serverApi2 = _interopRequireDefault(_serverApi);

// this function call by sagaWatcher when user type new value in searchInput
var LOADING = _reduxConsts2['default'].LOADING;
var SUCCESS_WITH_ZERO_RESULTS = _reduxConsts2['default'].SUCCESS_WITH_ZERO_RESULTS;
var ERROR = _reduxConsts2['default'].ERROR;
var NETWORK_ERROR = _reduxConsts2['default'].NETWORK_ERROR;
var SUCCESS = _reduxConsts2['default'].SUCCESS;

function getDocumentByObjectIdWorker(action) {
  var className, objectId, include, res, errType, data, _queryStatus;

  return regeneratorRuntime.wrap(function getDocumentByObjectIdWorker$(context$1$0) {
    while (1) switch (context$1$0.prev = context$1$0.next) {
      case 0:
        className = action.className;
        objectId = action.objectId;
        include = action.include;
        context$1$0.next = 5;
        return (0, _reduxSagaEffects.put)({
          type: _reduxTypes2['default'].SET_REQUEST_STATUS_BY_OBJECT_ID,
          objectId: objectId,
          status: LOADING
        });

      case 5:
        return context$1$0.delegateYield((0, _serverApiSagaWrapper.httpRequest)(_serverApi2['default'].query, className, { objectId: objectId }, null, null, null, null, include, null), 't0', 6);

      case 6:
        res = context$1$0.t0;

        if (!res.error) {
          context$1$0.next = 13;
          break;
        }

        errType = res.message === 'Network Error' ? NETWORK_ERROR : ERROR;
        context$1$0.next = 11;
        return (0, _reduxSagaEffects.put)({
          type: _reduxTypes2['default'].SET_REQUEST_STATUS_BY_OBJECT_ID,
          objectId: objectId,
          status: errType
        });

      case 11:
        context$1$0.next = 19;
        break;

      case 13:
        data = res.data.results ? res.data.results : [];
        _queryStatus = data.length > 0 ? SUCCESS : SUCCESS_WITH_ZERO_RESULTS;
        context$1$0.next = 17;
        return (0, _reduxSagaEffects.put)({ type: _reduxTypes2['default'].SET_DOCUMENT_BY_OBJECT_ID, objectId: objectId, data: data[0] });

      case 17:
        context$1$0.next = 19;
        return (0, _reduxSagaEffects.put)({
          type: _reduxTypes2['default'].SET_REQUEST_STATUS_BY_OBJECT_ID,
          objectId: objectId,
          status: _queryStatus
        });

      case 19:
      case 'end':
        return context$1$0.stop();
    }
  }, marked0$0[0], this);
}

// worker
module.exports = exports['default'];

// takeEvery,

// call,

// Second - run http Request with httpRequest wrapper that handle error
// const res = yield * httpRequest(api.query, 'DummyDataCategoriesConfig', query, null, null, null, null, include, order) // Make the request
// Make the request
// Check For error

// Set query status to error

// Handle Success
// extricate data from server response

// data = data[0].categoryData
// set data to sate
// Set query status - oneOf['SUCCESS','SUCCESS_WITH_ZERO_RESULTS]