/**
 * # redux > market > sagaWorkers > createLocalDocumentByUniqueIdWorker.js
 *
 * market Worker
 */

/* eslint no-console: ["error", { allow: ["warn", "error"] }] */
/**
 * Project requirements
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = createLocalDocumentByUniqueIdWorker;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var marked0$0 = [createLocalDocumentByUniqueIdWorker].map(regeneratorRuntime.mark);

var _reduxSagaEffects = require('redux-saga/effects');

// const _ = require('lodash')

var _serverApiSagaWrapper = require('../../server/apiSagaWrapper');

var _reduxTypes = require('../redux/types');

var _reduxTypes2 = _interopRequireDefault(_reduxTypes);

var _reduxConsts = require('../redux/consts');

var _reduxConsts2 = _interopRequireDefault(_reduxConsts);

// import {getDataFromState} from '../reducer'

var _serverApi = require('../../server/api');

var _serverApi2 = _interopRequireDefault(_serverApi);

var _helpers = require('../../helpers');

// this function call by sagaWatcher when user type new value in searchInput
var CREATE_DOCUMENT_START = _reduxConsts2['default'].CREATE_DOCUMENT_START;
var CREATE_DOCUMENT_ERROR = _reduxConsts2['default'].CREATE_DOCUMENT_ERROR;
var CREATE_DOCUMENT_SUCCESS = _reduxConsts2['default'].CREATE_DOCUMENT_SUCCESS;
var ERROR = _reduxConsts2['default'].ERROR;
var NETWORK_ERROR = _reduxConsts2['default'].NETWORK_ERROR;

function createLocalDocumentByUniqueIdWorker(action) {
  var documentsByUniqueId, className, uniqueId, parseDataBeforeSave, addMemberPointerToDataOnPost, getDataWithPostQueryStatusSuccessfully, documentData, objectToUpdate, imputableData, res, errType;
  return regeneratorRuntime.wrap(function createLocalDocumentByUniqueIdWorker$(context$1$0) {
    while (1) switch (context$1$0.prev = context$1$0.next) {
      case 0:
        context$1$0.next = 2;
        return (0, _reduxSagaEffects.select)(function (state) {
          return state.parse.documentsByUniqueId;
        });

      case 2:
        documentsByUniqueId = context$1$0.sent;
        className = action.className;
        uniqueId = action.uniqueId;
        parseDataBeforeSave = action.parseDataBeforeSave;
        addMemberPointerToDataOnPost = action.addMemberPointerToDataOnPost;
        getDataWithPostQueryStatusSuccessfully = action.getDataWithPostQueryStatusSuccessfully;
        documentData = undefined;
        objectToUpdate = null;

        if (!(documentsByUniqueId && uniqueId)) {
          context$1$0.next = 16;
          break;
        }

        imputableData = documentsByUniqueId.get(uniqueId);

        if (imputableData) {
          context$1$0.next = 14;
          break;
        }

        return context$1$0.abrupt('return');

      case 14:
        // remove readonly keys
        objectToUpdate = imputableData.filter(function (key, i) {
          return ['createdAt', 'updatedAt', 'objectId', 'ACL'].indexOf(i) === -1;
        });
        // convert to javascript
        objectToUpdate = objectToUpdate.toJS();

      case 16:
        if (addMemberPointerToDataOnPost) {
          objectToUpdate.member = (0, _helpers.GetPointerObject)('Member', currentUser.memberId);
        }
        if (parseDataBeforeSave) {
          objectToUpdate = parseDataBeforeSave(objectToUpdate);
        }
        context$1$0.next = 20;
        return (0, _reduxSagaEffects.put)({
          type: _reduxTypes2['default'].SET_REQUEST_STATUS_BY_UNIQUE_ID,
          uniqueId: uniqueId,
          status: CREATE_DOCUMENT_START
        });

      case 20:
        return context$1$0.delegateYield((0, _serverApiSagaWrapper.httpRequest)(_serverApi2['default'].createObject, className, objectToUpdate), 't0', 21);

      case 21:
        res = context$1$0.t0;

        if (!res.error) {
          context$1$0.next = 30;
          break;
        }

        context$1$0.next = 25;
        return (0, _reduxSagaEffects.put)({
          type: _reduxTypes2['default'].SET_REQUEST_STATUS_BY_UNIQUE_ID,
          uniqueId: uniqueId,
          status: CREATE_DOCUMENT_ERROR
        });

      case 25:
        errType = res.message === 'Network Error' ? NETWORK_ERROR : ERROR;
        context$1$0.next = 28;
        return (0, _reduxSagaEffects.put)({
          type: _reduxTypes2['default'].SET_REQUEST_STATUS_BY_UNIQUE_ID,
          uniqueId: uniqueId,
          status: errType
        });

      case 28:
        context$1$0.next = 35;
        break;

      case 30:
        if (!getDataWithPostQueryStatusSuccessfully) {
          context$1$0.next = 33;
          break;
        }

        return context$1$0.delegateYield((0, _serverApiSagaWrapper.httpRequest)(_serverApi2['default'].query, className, { objectId: res.data.objectId }), 't1', 32);

      case 32:
        documentData = context$1$0.t1;

      case 33:
        context$1$0.next = 35;
        return (0, _reduxSagaEffects.put)({
          type: _reduxTypes2['default'].SET_REQUEST_STATUS_BY_UNIQUE_ID,
          uniqueId: uniqueId,
          objectId: res.data.objectId,
          status: CREATE_DOCUMENT_SUCCESS,
          data: documentData ? (0, _helpers.dig)(documentData, 'data.results[0]') : null
        });

      case 35:
      case 'end':
        return context$1$0.stop();
    }
  }, marked0$0[0], this);
}

// worker
module.exports = exports['default'];

// takeEvery,

// call,

// Second - run http Request with httpRequest wrapper that handle error
// const res = yield * httpRequest(api.query, 'DummyDataCategoriesConfig', query, null, null, null, null, include, order) // Make the request
// Make the request
// Check For error

// Set query status to error

// Set query status - oneOf['SUCCESS','SUCCESS_WITH_ZERO_RESULTS]