/**
 * # redux > market > sagaWorkers > updateDocumentOnServerByObjectIdWorker.js
 *
 * market Worker
 */

/* eslint no-console: ["error", { allow: ["warn", "error"] }] */
/**
 * Project requirements
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = updateDocumentOnServerByObjectIdWorker;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var marked0$0 = [updateDocumentOnServerByObjectIdWorker].map(regeneratorRuntime.mark);

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i]; return arr2; } else { return Array.from(arr); } }

var _reduxSagaEffects = require('redux-saga/effects');

// const _ = require('lodash')

var _serverApiSagaWrapper = require('../../server/apiSagaWrapper');

var _reduxTypes = require('../redux/types');

var _reduxTypes2 = _interopRequireDefault(_reduxTypes);

var _reduxConsts = require('../redux/consts');

var _reduxConsts2 = _interopRequireDefault(_reduxConsts);

// import {getDataFromState} from '../reducer'

var _serverApi = require('../../server/api');

var _serverApi2 = _interopRequireDefault(_serverApi);

// this function call by sagaWatcher when user type new value in searchInput
var UPDATE_DOCUMENT_START = _reduxConsts2['default'].UPDATE_DOCUMENT_START;
var UPDATE_DOCUMENT_ERROR = _reduxConsts2['default'].UPDATE_DOCUMENT_ERROR;
var UPDATE_DOCUMENT_SUCCESS = _reduxConsts2['default'].UPDATE_DOCUMENT_SUCCESS;
var ERROR = _reduxConsts2['default'].ERROR;
var NETWORK_ERROR = _reduxConsts2['default'].NETWORK_ERROR;

function updateDocumentOnServerByObjectIdWorker(action) {
  var documentsByObjectId, className, objectId, keys, parseDataBeforeSave, objectToUpdate, imputableData, res, errType;
  return regeneratorRuntime.wrap(function updateDocumentOnServerByObjectIdWorker$(context$1$0) {
    while (1) switch (context$1$0.prev = context$1$0.next) {
      case 0:
        context$1$0.next = 2;
        return (0, _reduxSagaEffects.select)(function (state) {
          return state.parse.documentsByObjectId;
        });

      case 2:
        documentsByObjectId = context$1$0.sent;
        className = action.className;
        objectId = action.objectId;
        keys = action.keys;
        parseDataBeforeSave = action.parseDataBeforeSave;
        objectToUpdate = null;

        if (!(documentsByObjectId && objectId)) {
          context$1$0.next = 15;
          break;
        }

        imputableData = documentsByObjectId.get(objectId);

        if (imputableData) {
          context$1$0.next = 12;
          break;
        }

        return context$1$0.abrupt('return');

      case 12:
        // remove readonly keys
        objectToUpdate = imputableData.filter(function (key, i) {
          return ['createdAt', 'updatedAt', 'objectId', 'ACL'].indexOf(i) === -1;
        });
        // if action contain keys then update only this keys
        if (keys && keys.length > 0) {
          objectToUpdate = objectToUpdate.filter(function (key, i) {
            return [].concat(_toConsumableArray(keys)).indexOf(i) !== -1;
          });
        }
        // create new instance and convert to javascript
        objectToUpdate = Object.assign({}, objectToUpdate.toJS());

      case 15:
        if (parseDataBeforeSave) {
          objectToUpdate = parseDataBeforeSave(objectToUpdate);
        }
        context$1$0.next = 18;
        return (0, _reduxSagaEffects.put)({
          type: _reduxTypes2['default'].SET_REQUEST_STATUS_BY_OBJECT_ID,
          objectId: objectId,
          status: UPDATE_DOCUMENT_START
        });

      case 18:
        return context$1$0.delegateYield((0, _serverApiSagaWrapper.httpRequest)(_serverApi2['default'].updateObject, className, objectId, objectToUpdate), 't0', 19);

      case 19:
        res = context$1$0.t0;

        if (!res.error) {
          context$1$0.next = 28;
          break;
        }

        context$1$0.next = 23;
        return (0, _reduxSagaEffects.put)({
          type: _reduxTypes2['default'].SET_REQUEST_STATUS_BY_OBJECT_ID,
          objectId: objectId,
          status: UPDATE_DOCUMENT_ERROR
        });

      case 23:
        errType = res.message === 'Network Error' ? NETWORK_ERROR : ERROR;
        context$1$0.next = 26;
        return (0, _reduxSagaEffects.put)({
          type: _reduxTypes2['default'].SET_REQUEST_STATUS_BY_OBJECT_ID,
          objectId: objectId,
          status: errType
        });

      case 26:
        context$1$0.next = 30;
        break;

      case 28:
        context$1$0.next = 30;
        return (0, _reduxSagaEffects.put)({
          type: _reduxTypes2['default'].SET_REQUEST_STATUS_BY_OBJECT_ID,
          objectId: objectId,
          status: UPDATE_DOCUMENT_SUCCESS
        });

      case 30:
      case 'end':
        return context$1$0.stop();
    }
  }, marked0$0[0], this);
}

// worker
module.exports = exports['default'];

// takeEvery,

// call,

// Second - run http Request with httpRequest wrapper that handle error
// const res = yield * httpRequest(api.query, 'DummyDataCategoriesConfig', query, null, null, null, null, include, order) // Make the request
// Make the request
// Check For error

// Set query status to error

// Set query status - oneOf['SUCCESS','SUCCESS_WITH_ZERO_RESULTS]

// if(!action.disabledAutoGetAfterSave) {
//   yield put(getDocumentByObjectId(className, objectId))
// }